From 6d384047852a618779c5ee33212e96ff87a153cd Mon Sep 17 00:00:00 2001
From: Thiago Moreira <thiago.cmoreira@yahoo.com.br>
Date: Oct 03 2017 20:44:25 +0000
Subject: [PATCH 2/6] Refactoring navbar and fixing errors validations


- Adding autorefresh to tables
- Adding listerrors component and manupulating json.
- Refactor ErrorsTable and modify errors table
- Add bootstrap navbar
- Change errors table and add filter and pagination
- Add logo in navbar and put navbar in pags base
- Added some validations, message field and improving errorstable.

 Signed-off-by: rafaelrabetti <rafael.rabetti@gmail.com>
 Signed-off-by: eduardonunes <eduardonunes2525@gmail.com>

---

diff --git a/src/App.vue b/src/App.vue
index 0ec5f1f..ea74cf1 100644
--- a/src/App.vue
+++ b/src/App.vue
@@ -1,6 +1,7 @@
 <template>
-  <div id="app"> 
-    <router-view></router-view>
+  <div id="app">
+    <header-kiskadee />
+    <router-view />
   </div>
 </template>
 
@@ -9,12 +10,15 @@ import Vue from 'vue'
 import VueMaterial from 'vue-material'
 import 'vue-material/dist/vue-material.css'
 import Vuex from 'vuex'
+import HeaderK from './components/shared/HeaderK.vue'
 
 Vue.use(VueMaterial)
 Vue.use(Vuex)
 
 export default {
-
+  components: {
+    'header-kiskadee': HeaderK
+  }
 }
 </script>
 
diff --git a/src/components/analyzis/PieChart.vue b/src/components/analyzis/PieChart.vue
new file mode 100644
index 0000000..8abb439
--- /dev/null
+++ b/src/components/analyzis/PieChart.vue
@@ -0,0 +1,32 @@
+<template>
+ <div>
+  <pie-chart :data="data" :options="options"></pie-chart>
+ </div>
+</template>
+
+<script>
+import PieChart from '../../helpers/Charts.js'
+export default {
+  components: {
+    'pie-chart': PieChart
+  },
+  props: {
+    data: {
+      type: Object,
+      required: true
+    },
+    options: {
+      type: Object,
+      required: false
+    }
+  }
+}
+</script>
+
+<style lang="scss" scoped>
+  div {
+    padding-top: 50px; 
+    max-width: 450px;
+    margin: 0 auto;
+  }
+</style>
\ No newline at end of file
diff --git a/src/components/home/Home.vue b/src/components/home/Home.vue
index 8039518..44d1d4c 100644
--- a/src/components/home/Home.vue
+++ b/src/components/home/Home.vue
@@ -1,25 +1,18 @@
 <template>
   <div>
-    <header-kiskadee></header-kiskadee>
     <list-packages></list-packages>
-    <analyzer-errors></analyzer-errors>
   </div>
 </template>
 
 <script>
-import HeaderK from '../shared/HeaderK.vue'
 import List from '../packages/List.vue'
-import AnalyzerErrors from '../analyze/AnalyzerErrors'
 
 export default {
   components: {
-    'header-kiskadee': HeaderK,
-    'list-packages': List,
-    'analyzer-errors': AnalyzerErrors
+    'list-packages': List
   }
 }
 </script>
 
 <style lang="scss" scoped>
-
-</style>
\ No newline at end of file
+</style>
diff --git a/src/components/packages/ErrorsTable.vue b/src/components/packages/ErrorsTable.vue
new file mode 100644
index 0000000..6e61720
--- /dev/null
+++ b/src/components/packages/ErrorsTable.vue
@@ -0,0 +1,118 @@
+<template>
+<div>
+  <b-card header-tag="header" footer-tag="footer">
+    <h6 slot="header" class="mb-0">
+            <div class="my-1 row">
+                <div class="col-md-6">
+                    <b-form-fieldset horizontal label="Rows per page" :label-cols="6">
+                        <b-form-select :options="pageOptions" v-model="perPage" />
+                        </b-form-fieldset>
+                    </div>
+                    <div class="col-md-6">
+                        <b-form-fieldset horizontal label="Filter" :label-cols="3">
+                            <b-form-input v-model="filter" placeholder="Type to Search" />
+                            </b-form-fieldset>
+                        </div>
+                    </div>
+                </h6>
+    <em slot="footer">
+                    <b-pagination align="center" :total-rows="totalRows" :per-page="perPage" v-model="currentPage" />
+                    </em>
+    <p class="card-text">
+      <b-table striped hover show-empty
+      :items="items"
+      :fields="fields"
+      :current-page="currentPage"
+      :per-page="perPage"
+      :filter="filter"
+      :sort-by.sync="sortBy"
+      :sort-desc.sync="sortDesc"
+      @filtered="onFiltered"
+      >
+        <template slot="path" scope="row" />
+        <template slot="line" scope="row" />
+        <template slot="type" scope="row" />
+        <template slot="message" scope="row" />
+      </b-table>
+    </p>
+  </b-card>
+</div>
+</template>
+
+<script>
+
+var items = require('./jsonItems')
+
+export default {
+  data() {
+    return {
+      items: this.makeErrorsTable(),
+      fields: {
+        path: {
+          label: 'Path',
+          sortable: true
+        },
+        line: {
+          label: 'Line : Column'
+        },
+        type: {
+          label: 'Type',
+          sortable: true,
+          'class': 'text-center'
+        },
+        message: {
+          label: 'Message'
+        }
+
+      },
+      currentPage: 1,
+      perPage: 5,
+      totalRows: items.length,
+      pageOptions: [{
+        text: 5,
+        value: 5
+      }, {
+        text: 10,
+        value: 10
+      }, {
+        text: 15,
+        value: 15
+      }],
+      sortBy: null,
+      sortDesc: false,
+      filter: null
+    }
+  },
+  methods: {
+    makeErrorsTable() {
+      if (this.isThereAnyErrors()) {
+        let errorsList = items[0].results.map((errorsObject) => {
+          let lineColumn = errorsObject.location.point.line + " : " + errorsObject.location.point.column
+          return {
+            'path': errorsObject.location.file.givenpath,
+            'line': lineColumn,
+            'type': errorsObject.testid,
+            'message': errorsObject.message.text
+          }
+        })
+        return errorsList
+      } else {
+        let emptyArray = []
+        return emptyArray
+      }
+    },
+    isThereAnyErrors() {
+      let errors = items[0].results
+      if (errors.length != 0) {
+        return true
+      } else {
+        return false
+      }
+    },
+    onFiltered(filteredItems) {
+      this.totalRows = filteredItems.length
+      this.currentPage = 1
+    }
+  }
+}
+</script>
diff --git a/src/components/shared/HeaderK.vue b/src/components/shared/HeaderK.vue
index d2e69e5..dab3cca 100644
--- a/src/components/shared/HeaderK.vue
+++ b/src/components/shared/HeaderK.vue
@@ -1,36 +1,37 @@
 <template>
-  <div>
-    <md-toolbar>
-      <md-layout md-order="start">
-        <md-layout :md-flex="5">
-          <md-icon>menu</md-icon>
-        </md-layout>
-        <md-layout :md-flex="15">
-          <h2 class="md-title;">Kiskadee</h2>
-        </md-layout>
-        <md-layout md-flex-offset="50" >
-            <form novalidate @submit.stop.prevent="submit">
-              <md-input-container>
-                <md-input placeholder="Find package"></md-input>
-              </md-input-container>
-            </form>
-        </md-layout>
-      </md-layout>
-    </md-toolbar>
-  </div>
+    <b-navbar toggleable="md" type="light" variant="light">
+        <b-nav-toggle target="nav_text_collapse" />
+        <b-navbar-brand href='#'>
+            <h2>
+                <img src="../../assets/kiskadee_logo.png" width="35" height="35" class="d-inline-block align-top" alt="logo">
+                {{say_my_name}}
+            </h2>
+        </b-navbar-brand>
+        <b-collapse is-nav id="nav_text_collapse">
+            <b-nav is-nav-bar>
+                <!--<b-nav-item href="#">Packages List</b-nav-item>-->
+            </b-nav>
+        </b-collapse>
+    </b-navbar>
 </template>
 
 <script>
 export default {
-  data () {
-    return {
-      say_my_name: 'Kiskadee'
+    data () {
+        return {
+            say_my_name: 'Kiskadee'
+        }
     }
-  }
 }
 
 </script>
 
 <style scoped>
+@import url('https://fonts.googleapis.com/css?family=Comfortaa:700');
 
+a:link, a:visited {
+    font-family: 'Comfortaa', cursive;
+    color: #3e6eb3;
+    text-decoration: none;
+}
 </style>
diff --git a/src/helpers/Charts.js b/src/helpers/Charts.js
new file mode 100644
index 0000000..0eaf32a
--- /dev/null
+++ b/src/helpers/Charts.js
@@ -0,0 +1,10 @@
+import Chartjs from 'vue-chartjs'
+
+var PieChart = Chartjs.Pie.extend({
+  props: ['data', 'options'],
+  mounted () {
+    this.renderChart(this.data, this.options)
+  }
+})
+
+export default PieChart
